<?php


namespace App\Controllers;



use App\Models\CountryModel;
use App\Models\TestModel;

class Main extends BaseController
{

    private $db;

    public function __construct()
    {
//        $this->db = \Config\Database::connect();
//        $this->db = db_connect('tests');
        $this->db = new CountryModel();
    }

    public function index()
    {
        $data = [
            'title' => 'Главная страница',
        ];
        return view('main/index', $data);
    }

    public function test()
    {
        helper('form');
        $rules = [
            'name' => [
                'rules' => 'required|min_length[6]',
                /*'errors' => [
                    'required' => 'The field {field} is required',
                    'min_length' => 'The field {field} must be at least 6 characters in length'
                ],*/
                'label' => 'Name',
            ],
            'email' => [
                'rules' => 'valid_email',
                'errors' => [
                    'valid_email' => 'Поле {field} должно содержать корректный адрес',
                ],
                'label' => 'E-mail',
            ],
        ];
        $data = ['title' => 'Validation data'];

        if ($this->request->getMethod() == 'post') {
            if (!$this->validate($rules)) {
                return redirect()->route('main.test')->withInput()->with('errors', $this->validator);
            } else {
                return redirect()->route('main.test')->with('success', 'SUCCESS');
            }
        }

        return view('main/test', $data);
    }

    public function test2()
    {
        helper('form');

        if ($this->request->getMethod() == 'post') {
            $testModel = new TestModel();
            if (!$testModel->insert($this->request->getPost())) {
                return redirect()->route('main.test2')->withInput()->with('errors', $testModel->errors());
            }
            return redirect()->route('main.test2')->with('success', 'SUCCESS');
        }

        return view('main/test2', ['title' => 'Validation data 2']);
    }

    public function fileUpload()
    {
        if ($this->request->getMethod() == 'post') {
            $file = $this->request->getFile('userfile');
            if ($file->isValid() && !$file->hasMoved()) {
//                $f = $file->store('test', '100.jpg');
//                d($f);
                $f = date("Ymd");
                if ($file->move("uploads/{$f}", $n = $file->getRandomName())) {
                    session()->setFlashdata('file', "{$f}/$n");
                    return redirect()->route('main.fileupload')->with('success', 'Success uploaded');
                } else {
                    return redirect()->route('main.fileupload')->with('errors', 'Error moved file');
                }
            }
            /*d($file->getName());
            d($file->getClientName());
            d($file->getTempName());
            d($file->getClientExtension());
            d($file->guessExtension());*/
        }
        return view('main/file-upload', ['title' => 'File upload']);
    }

    public function fileUpload3()
    {
        helper('form');
        $rules = [
            'name' => 'required',
            'email' => 'valid_email',
            'userfile' => 'uploaded[userfile.0]|max_size[userfile,1024]|ext_in[userfile,png,jpg,gif]',
        ];

        if ($this->request->getMethod() == 'post') {

            if ($this->validate($rules)) {
                $files = $this->request->getFiles();
                $names = [];

                foreach ($files['userfile'] as $file) {
                    if ($file->isValid() && !$file->hasMoved()) {
                        $f = date("Ymd");
                        if ($file->move("uploads/{$f}", $n = $file->getRandomName())) {
                            $names[] = "{$f}/$n";
                        } else {
                            return redirect()->route('main.fileupload3')->with('errors', ['Error moved file']);
                        }
                    }
                }

            } else {
                return redirect()->route('main.fileupload3')->withInput()->with('errors', $this->validator->getErrors());
            }

            session()->setFlashdata('files', $names);
            return redirect()->route('main.fileupload3')->with('success', 'Success');

        }

        return view('main/file-upload3', ['title' => 'File upload 3']);
    }

    public function fileUpload2()
    {
        helper('form');
        $rules = [
            'userfile' => 'uploaded[userfile]|is_image[userfile]',
        ];

        if ($this->request->getMethod() == 'post') {
            $file = $this->request->getFile('userfile');

            if ($this->validate($rules)) {
                if ($file->isValid() && !$file->hasMoved()) {
                    $f = date("Ymd");
                    if ($file->move("uploads/{$f}", $n = $file->getRandomName())) {

                        if (!is_dir("uploads/thumbs/{$f}")) {
                            mkdir("uploads/thumbs/{$f}", 0755);
                        }
                        $image = \Config\Services::image();
//                        $image = service('image');
                        $image->withFile("uploads/{$f}/$n")
                            ->fit(200, 200, 'center')
                            ->flip('horizontal')
                            //->rotate(180)
                            //->resize(200, 200, true)
                            //->crop(500, 200)
                            ->save("uploads/thumbs/{$f}/$n");

                        session()->setFlashdata('file', "{$f}/$n");
                    } else {
                        return redirect()->route('main.fileupload2')->with('errors', ['Error moved file']);
                    }
                }
            } else {
                return redirect()->route('main.fileupload2')->withInput()->with('errors', $this->validator->getErrors());
            }

            return redirect()->route('main.fileupload2')->with('success', 'Success');

        }

        return view('main/file-upload2', ['title' => 'File upload 2']);
    }

}